package middleware

import (
	"encoding/json"
	"strings"

	"github.com/labstack/echo"
)

func JsonBodyHandler(c echo.Context, req []byte, res []byte) {
	reqM := make(map[string]interface{})
	resM := make(map[string]interface{})
	if isJsonReq(c) {
		json.Unmarshal(req, &reqM)
	}
	if isJsonRes(c) {
		json.Unmarshal(res, &resM)
	}
	data := map[string]interface{}{
		"url": c.Request().URL,
		"req": reqM,
		"res": resM,
	}
	c.Logger().Debugj(data)
}

func isJsonReq(c echo.Context) bool {
	reqCt := strings.ToLower(c.Request().Header.Get("Content-Type"))
	return strings.HasPrefix(reqCt, "application/json")
}

func isJsonRes(c echo.Context) bool {
	resCt := strings.ToLower(c.Response().Header().Get("Content-Type"))
	return strings.HasPrefix(resCt, "application/json")
}
