package middleware

import (
	"gopkg.in/go-playground/validator.v9"
)

type ValidatorErrWarper func(err error) error

type ReqParamValidate struct {
	validator *validator.Validate
	errwarper ValidatorErrWarper
}

func NewReqParamValidate(errwarper ValidatorErrWarper) *ReqParamValidate {
	return &ReqParamValidate{validator: validator.New(), errwarper: errwarper}
}

func (v *ReqParamValidate) Validate(i interface{}) error {
	err := v.validator.Struct(i)
	if err != nil {
		panic(v.errwarper(err))
	}
	return nil
}
