package helper

import (
	. "gopher/ak/error"
	"net/http"
)

func CheckError(err error) {
	if err == nil {
		return
	}
	unkown := NewReqStat("ERR_SERVER_EXCEPTION", err.Error(), http.StatusInternalServerError)
	panic(unkown)
}

func CheckErrorWithIgnore(err error, ignore ...error) {
	if err == nil {
		return
	}

	for _, ie := range ignore {
		if err == ie {
			return
		}
	}

	unkown := NewReqStat("ERR_SERVER_EXCEPTION", err.Error(), http.StatusInternalServerError)
	panic(unkown)
}

func Verify(exp bool, err error) {
	if !exp {
		return
	}

	if _, ok := err.(ReqStat); ok {
		panic(err)
	}

	unkown := NewReqStat("ERR_SERVER_EXCEPTION", err.Error(), http.StatusInternalServerError)
	panic(unkown)
}

func Assert(exp bool, err error) {
	if exp {
		return
	}

	if _, ok := err.(ReqStat); ok {
		panic(err)
	}

	unkown := NewReqStat("ERR_SERVER_EXCEPTION", err.Error(), http.StatusInternalServerError)
	panic(unkown)
}
