// Code generated by m2c. DO NOT EDIT.
package user

import (
	"github.com/globalsign/mgo"
	"github.com/globalsign/mgo/bson"
	id "gopher/ak/orm/id"
	"time"
)

var (
	userTable *mgo.Collection
	db        *mgo.Database
)

func Init(mgo *mgo.Database) {
	db = mgo
	userTable = mgo.C("user")
}

type User struct {
	// auto bind
	Id    int64 `json:"id" bson:"_id"`
	CTime int64 `json:"ctime" bson:"ctime"`
	MTime int64 `json:"mtime" bson:"mtime"`
	// basic type
	Email string `json:"email" bson:"email"` //  邮箱
	Name  string `json:"name" bson:"name"`   //  用户名
	// relation
}

func NewUser(email string, name string) *User {
	return &User{
		Email: email,
		Name:  name,
	}
}

func GetUserTable() *mgo.Collection {
	return userTable
}

func Get(id int64) (user *User, err error) {
	user = &User{}
	err = userTable.FindId(id).One(user)
	if err != nil && err.Error() == "not found" {
		user = nil
		err = nil
	}
	return
}

func MustGet(id int64, outerr error) (user *User) {
	user = &User{}
	err := userTable.FindId(id).One(user)
	if err != nil && err.Error() == "not found" {
		user = nil
		err = nil
	}

	if err != nil {
		panic(err)
	}

	if user == nil {
		panic(outerr)
	}
	return
}

func Save(user *User) (err error) {
	if user.Id == 0 {
		user.Id = id.Gen("user")
	}
	now := time.Now().Unix()
	if user.CTime == 0 {
		user.CTime = now
	}
	user.MTime = now
	_, err = userTable.UpsertId(user.Id, user)
	return
}

func Update(id int64, updater map[string]interface{}) (user *User, err error) {
	now := time.Now().Unix()
	updater["mtime"] = now
	change := mgo.Change{
		Update:    bson.M{"$set": updater},
		Upsert:    true,
		ReturnNew: true,
	}
	user = &User{}
	_, err = userTable.Find(bson.M{"_id": id}).Apply(change, user)
	if err != nil {
		user = nil
	}
	return
}

func Delete(id int64) (err error) {
	err = userTable.RemoveId(id)
	if err != nil && err.Error() == "not found" {
		err = nil
	}
	return
}

type UserQuery struct {
	pageIndex int
	pageSize  int
	filter    bson.M
	or        []bson.M
	sort      []string
}

func Query() *UserQuery {
	return &UserQuery{
		filter: bson.M{},
		or:     []bson.M{},
	}
}

func (userQuery *UserQuery) GetQuery() bson.M {
	if len(userQuery.or) > 0 {
		userQuery.filter["$or"] = userQuery.or
	}
	return userQuery.filter
}

func (userQuery *UserQuery) WithPage(pageIndex int64, pageSize int64) *UserQuery {
	userQuery.pageIndex = int(pageIndex-1) * int(pageSize)
	userQuery.pageSize = int(pageSize)
	return userQuery
}

func (userQuery *UserQuery) WithFilter(filter map[string]interface{}) *UserQuery {
	if len(userQuery.filter) == 0 {
		userQuery.filter = filter
	} else {
		for k, v := range filter {
			userQuery.filter[k] = v
		}
	}
	return userQuery
}

func (userQuery *UserQuery) WithIn(key string, values interface{}) *UserQuery {
	userQuery.filter[key] = bson.M{"$in": values}
	return userQuery
}

func (userQuery *UserQuery) WithNotIn(key string, values interface{}) *UserQuery {
	userQuery.filter[key] = bson.M{"$nin": values}
	return userQuery
}

func (userQuery *UserQuery) WithSort(sort []string) *UserQuery {
	userQuery.sort = sort
	return userQuery
}

func (userQuery *UserQuery) WithTextSearch(text string) *UserQuery {
	userQuery.filter["$text"] = bson.M{"$search": text}
	return userQuery
}

// https://docs.mongodb.com/manual/reference/operator/query/or/#or-and-text-queries
func (userQuery *UserQuery) OrTextSearch(text string) *UserQuery {
	userQuery.or = append(userQuery.or, bson.M{"$text": bson.M{"$search": text}})
	return userQuery
}

func (userQuery *UserQuery) Count() (n int64, err error) {
	_n, err := userTable.Find(userQuery.GetQuery()).Count()
	n = int64(_n)
	return
}

func (userQuery *UserQuery) Update(updater map[string]interface{}) (updated int64, err error) {
	now := time.Now().Unix()
	updater["mtime"] = now
	change := bson.M{"$set": updater}
	info, err := userTable.UpdateAll(userQuery.GetQuery(), change)
	if err != nil {
		return
	}
	updated = int64(info.Updated)
	return
}

func (userQuery *UserQuery) One() (user *User, err error) {
	user = &User{}
	err = userTable.Find(userQuery.GetQuery()).Sort(userQuery.sort...).One(user)
	if err != nil && err.Error() == "not found" {
		user = nil
		err = nil
	}
	return
}

func (userQuery *UserQuery) MustOne(outerr error) (user *User) {
	user = &User{}
	err := userTable.Find(userQuery.GetQuery()).Sort(userQuery.sort...).One(user)
	if err != nil && err.Error() == "not found" {
		user = nil
		err = nil
	}

	if err != nil {
		panic(err)
	}

	if user == nil {
		panic(outerr)
	}
	return
}

func (userQuery *UserQuery) All() (user []*User, err error) {
	user = []*User{}
	err = userTable.Find(userQuery.GetQuery()).Skip(userQuery.pageIndex).Limit(userQuery.pageSize).Sort(userQuery.sort...).All(&user)
	return
}

func (userQuery *UserQuery) Scan() (ch chan *User, err chan error) {
	iter := userTable.Find(userQuery.GetQuery()).Iter()
	ch = make(chan *User)
	err = make(chan error)
	go func() {
		defer iter.Close()
		defer close(ch)
		defer close(err)
		for {
			p := &User{}
			if ok := iter.Next(p); ok {
				if p.CTime != 0 { // empty object
					ch <- p
				}
			}
			if iter.Err() != nil {
				err <- iter.Err()
				return
			}
			if iter.Done() {
				return
			}
		}
	}()
	return
}

// save user
func (user *User) Save() (err error) {
	if user.Id == 0 {
		user.Id = id.Gen("user")
	}
	now := time.Now().Unix()
	if user.CTime == 0 {
		user.CTime = now
	}
	user.MTime = now
	_, err = userTable.UpsertId(user.Id, user)
	return
}

func (userQuery *UserQuery) WithEmailEqual(email string) *UserQuery {
	userQuery.filter["email"] = email
	return userQuery
}

func (userQuery *UserQuery) WithEmailNotEqual(email string) *UserQuery {
	userQuery.filter["email"] = bson.M{"$ne": email}
	return userQuery
}

func (userQuery *UserQuery) OrEmailLike(email string) *UserQuery {
	userQuery.or = append(userQuery.or, bson.M{"email": bson.M{"$regex": email}})
	return userQuery
}
func (userQuery *UserQuery) WithEmailLike(email string) *UserQuery {
	userQuery.filter["email"] = bson.M{"$regex": email}
	return userQuery
}

func (userQuery *UserQuery) WithNameEqual(name string) *UserQuery {
	userQuery.filter["name"] = name
	return userQuery
}

func (userQuery *UserQuery) WithNameNotEqual(name string) *UserQuery {
	userQuery.filter["name"] = bson.M{"$ne": name}
	return userQuery
}

func (userQuery *UserQuery) OrNameLike(name string) *UserQuery {
	userQuery.or = append(userQuery.or, bson.M{"name": bson.M{"$regex": name}})
	return userQuery
}
func (userQuery *UserQuery) WithNameLike(name string) *UserQuery {
	userQuery.filter["name"] = bson.M{"$regex": name}
	return userQuery
}
