package token

import (
	"time"

	"github.com/go-redis/redis"
)

type TokenAuthOnRedis struct {
	tokenName string
	loginURL  string
	redisDB   *redis.Client
	expired   time.Duration
}

func NewTokenAuthOnRedis(tokenName, loginURL, redisURL string, expired time.Duration) *TokenAuthOnRedis {
	opts, err := redis.ParseURL(redisURL)
	if err != nil {
		panic(err)
	}
	return &TokenAuthOnRedis{
		tokenName: tokenName,
		loginURL:  loginURL,
		expired:   expired,
		redisDB:   redis.NewClient(opts),
	}
}
