#!/bin/bash

baseRoot=$(dirname $(pwd))
packDest=${baseRoot}/dist
buildRoot=${baseRoot}/gopher
confRoot=${buildRoot}/config/
walleRoot=${baseRoot}/deploy/walle
supervisorConf=${walleRoot}/supervisord/supervisor.conf
postRelease=${walleRoot}/post_release.sh

#sh walle/build.sh appname env
#构建环境test 或 prod
if [ -z $1 ] || [ -z $2 ];  then
    echo "需要指定构建项目名称和运行环境,如: sh build.sh appname test";
    exit 2;
fi;

appName=$1
env=$2
mkdir -p ${packDest} ${packDest}/config
#make conf yaml
configFile=${confRoot}${env}.yaml
if [ ! -f ${configFile} ]; then
    echo "Config File ${configFile} Not Exist"
    exit 2;
fi
cp -rfv ${configFile}  ${packDest}/config/dev.yaml
cp -rfv ${postRelease} ${packDest}

#go build
cd ${buildRoot}
/usr/local/go/bin/go build -mod=vendor -o ${packDest}/${appName}

#make supervisor conf
sed -i "s/project_name/${appName}/g" ${supervisorConf}
cp ${supervisorConf}  ${packDest}/${appName}.conf



