package cmd

import (
	"flag"
	"gopher/ak/orm"
	"gopher/config"
	"gopher/kit"
	"os"
)

type AppCMD struct {
	cfgpath string
	name    string
}

func NewAppCMD(cfgpath string, name string) *AppCMD {
	this := &AppCMD{
		cfgpath,
		name,
	}
	return this
}

func (this *AppCMD) Inject() {
	if len(os.Args) > 1 && os.Args[1] == this.name {
		this.delegate(os.Args[2:])
		os.Exit(0)
	}
}

func (this *AppCMD) delegate(args []string) {
	var isHello bool
	appcmd := flag.NewFlagSet("appcmd", flag.ExitOnError)
	appcmd.BoolVar(&isHello, "hello", false, "hello cmd")
	appcmd.Parse(args)

	if len(args) == 0 {
		appcmd.Usage()
	}

	// config
	config.Init(this.cfgpath)
	// kit
	kit.Init()
	// orm
	orm.Init(config.GlobalConfig.MongoURL)

	if isHello {
		HelloCmd()
	}
}
