package test

import (
	"fmt"
	. "gopher/ak/gw/model"
	"net/http"
	"net/http/httptest"
	"testing"

	"github.com/bxcodec/faker"
	"github.com/stretchr/testify/assert"

	stat "gopher/ak/error"
)

func TestExample(t *testing.T) {
	// Setup
	e := InitAll("../config/test.yaml", true)

	person := faker.GetPerson()
	email := fmt.Sprintf("%s@xyz.com", person.FirstName())
	name := person.Name()
	u1 := ReqExampleUserCreate{Email: &email, Name: &name}
	req := NewJsonPostRequest("/api/v1/example/user/create", u1)
	rec := httptest.NewRecorder()
	e.ServeHTTP(rec, req)
	assert.Equal(t, http.StatusOK, rec.Code)
	resp := NewApiResp(rec.Body.Bytes())
	assert.Equal(t, stat.OK.Stat, resp.Stat)

	ul := ReqExampleUserLogin{Email: &email}
	req1 := NewJsonPostRequest("/api/v1/example/user/login", ul)
	rec1 := httptest.NewRecorder()
	e.ServeHTTP(rec1, req1)
	assert.Equal(t, http.StatusOK, rec1.Code)
	resp1 := NewApiResp(rec1.Body.Bytes())
	assert.Equal(t, stat.OK.Stat, resp1.Stat)
	fmt.Println(resp1)

	req2 := NewJsonGetRequestWithCookies("/api/v1/example/user/info", rec1.Result().Cookies())
	rec2 := httptest.NewRecorder()
	e.ServeHTTP(rec2, req2)
	assert.Equal(t, http.StatusOK, rec2.Code)
	resp2 := NewApiResp(rec2.Body.Bytes())
	assert.Equal(t, stat.OK.Stat, resp2.Stat)
	fmt.Println(resp2)
}
