package token

import (
	"time"
)

type MemoryToken struct {
	m map[string]*token
}

func NewMemoryToken() TokenStore {
	return &MemoryToken{
		m: make(map[string]*token),
	}
}

func (s *MemoryToken) Add(key string, uid interface{}, expiredAfter time.Duration) (err error) {
	s.m[key] = &token{Key: key, UID: uid, ExpiredAt: time.Now().Add(expiredAfter)}
	return nil
}

func (s *MemoryToken) Get(key string) (uid interface{}, err error) {
	if tok, ok := s.m[key]; ok {
		if time.Now().After(tok.ExpiredAt) {
			delete(s.m, key)
			return nil, nil
		}
		return tok.UID, nil
	}
	return nil, nil
}
