# Mini Service
遵循Mini Service 开发规范, 以便应用可以快速上线云平台如k8s, 以及动态扩容

- 支持通过环境变量配置
- 进程无状态, 幂等, 确保应用可以快速动态扩容 (stateless, shared-nothing)
- 内存只用于缓存临时数据, 状态数据必须通过数据库等持久化
- 使用supverisor, systemd, init.d 等工具管理进程
- 把日志当成事件流处理, 直接输出到stdout (进程管理工具会捕获日志输出到文件, 数据库等做持久化)

## 目录
- gopher # 服务源码
    - app # 业务逻辑
    - cmd # 业务相关命令
- doc # 文档留存
- deploy # 部署帮助
- apimodel.txt # api模型
- objmodel.txt # obj模型

## 快速开始
1. 安装mini-service帮助工具
```
pip install m2c 
```

2. 初始工程
```
mkdir helloworld
cd helloworld
m2c init
```

3. 运行工程
```
m2c run
```

## How-TO
参考[how-to](./how-to.md)

参考: https://12factor.net/
