package object

import (
	"github.com/globalsign/mgo"
	"github.com/globalsign/mgo/bson"
)

var (
	idTable *mgo.Collection
)

type id struct {
	Seq int64 `bson:"seq"`
}

func Init(mgo *mgo.Database) {
	idTable = mgo.C("id")
}

func Gen(key string) int64 {
	change := mgo.Change{
		Update:    bson.M{"$inc": bson.M{"seq": 1}},
		Upsert:    true,
		ReturnNew: true,
	}
	doc := &id{}
	_, err := idTable.Find(bson.M{"_id": key}).Apply(change, &doc)
	if err != nil {
		panic(err)
	}
	return doc.Seq
}
